function [res,diff_from_targets] = doit(param, inputfolder, methodmom)
maxNumCompThreads(8);

if nargin < 3, methodmom='squareloss'; end

load base_cal/targets.mat targets

fprintf('  %9.9f \n',param);

%Parameters cannot go above or below bounds
lowerbounds_param=[0.15 0 0 0 0 0 0 0 0 0 0 0 0 1 1]';
upperbounds_param=[15 0.02 1 1 1 3 3 3 3 3 1 1 1 3 3]';

lowerbounds_param=lowerbounds_param(1:numel(param));
upperbounds_param=upperbounds_param(1:numel(param));
if sum(param(:)<lowerbounds_param(:)) + sum(param(:)>upperbounds_param(:)) > 0
    res=1000000; %if they do, return large value
    diff_from_targets=ones(numel(param),1)*1000;
else
    
    % Save parameters and solve problem
    if nargin < 2
        write_parameters(param);
        model_sons(); 
        moments=gen_moments();
    else
        if inputfolder > 99
            t = getCurrentTask();
            if isempty(t), writefolder=1;
            else, writefolder=t.ID;
            end
        else, writefolder=inputfolder;
        end
        
        write_parameters(param,writefolder);
        model_sons(writefolder);
        moments=gen_moments_exact(writefolder);
    end
    
    % Calculate the residual
    moments=moments(1:12);
    targets=targets(1:12);

    %adjustments for the likelihood ratio
    targets(4)=targets(4)-1;
    moments(4)=moments(4)-1;
    diff_from_targets=(moments-targets)./targets;
    if strcmp(methodmom,'squareloss'), res= sqrt(sum((diff_from_targets).^2)/numel(diff_from_targets));
    elseif strcmp(methodmom,'moments'), res=diff_from_targets; end
    
    fprintf('Total sum of abs loss is %g \n',sum(abs(diff_from_targets))/numel(diff_from_targets));
    figure(2); bar(diff_from_targets);
end

end