function res  = model_fathers(initial_ustate_becomefathers, initial_estate_becomefathers, theta, inputfolder )

%write_parameters_SPARSE_NEW_STATE_WITH_SONS;

starttic=tic;
%Parameters loaded here
if nargin < 4
    %Parameters loaded here
    load base_cal/parameters_model.mat 
else
    paramstring=sprintf('%g\\parameters_model.mat',inputfolder); load(paramstring);
end 


adj1=(j1_ind_fat==1)' + (n_occ-1)*(j1_ind_fat==2)'+ ((n_occ-1)*(j1_ind_fat==3))' + ...
    ((n_occ-1)*(j1_ind_fat==4))' + (n_occ-1)*(n_occ-2)*(j1_ind_fat==5)';

% %Initialize distribution of sons who become fathers
if nargin < 2 
%statesize_son=statesize_fat;
    initial_ustate_fathers=(ones(statesize_fat,1)).*adj1.*0.1; 
    initial_ustate_fathers=initial_ustate_fathers/sum(adj1);
    initial_estate_fathers=((ones(statesize_fat,1)).*adj1./sum(adj1))-initial_ustate_fathers; 
else
    initial_ustate_fathers=(transit_to_father')*(initial_ustate_becomefathers);
    initial_estate_fathers=(transit_to_father')*(initial_estate_becomefathers);
end

% Initialize Value Functions
U_father=ones(statesize_fat,1);   
W_father=ones(statesize_fat,1);   Eu_W_father=W_father; Ee_W_father=W_father;  
Eu_WR_father=ones(statesize_fat,1);
Ee_WR_father=ones(statesize_fat,1);

%ORDER OF VARIABLES
%1) Position (5 possible positions, in relation to your prod. and
% preferences: YYC, YNN, NYN, NNC, NNN)
%2) Level of Occ. HC
%3) Level of Occ. NET

%% Transition Function:

%Building the Transition Function of the State
trans_omega_E=(ones(statesize_fat));
trans_omega_U=(ones(statesize_fat));

% Alternative (FASTER AND MORE COMPACT) way:
statesize_bef_hc=n_pos;
statesize_after_hc=statesize_fat/(n_pos*n_hc);
statesize_bef_net=n_pos*n_hc;
statesize_after_net=statesize_fat/(n_pos*n_hc*n_net);
aux_matrix_hc=ones(statesize_bef_hc);
aux_matrix_net=ones(statesize_bef_net);

trans_omega_E=trans_omega_E.*repmat(kron(hc_trans_E,aux_matrix_hc),statesize_after_hc,statesize_after_hc) ...
    .*repmat(kron(net_trans_E,aux_matrix_net),statesize_after_net,statesize_after_net).*indicator_fat;

trans_omega_U=trans_omega_U.*repmat(kron(hc_trans_U,aux_matrix_hc),statesize_after_hc,statesize_after_hc) ...
    .*repmat(kron(net_trans_U,aux_matrix_net),statesize_after_net,statesize_after_net).*indicator_fat;

clear aux_matrix_hc aux_matrix_pref aux_matrix_adv aux_matrix_net

% For each state, identify the position in which they would go if they
% changed.
tic
wheretolook=repmat(pos_trans_occ,n_hc*n_net,1);
wheretolook(:,1)=[1:statesize_fat]';
wheretolook_trans=wheretolook';

%Useful stuff for later
[ind] = ind2sub(statesize_fat, 1:statesize_fat); % Indexes of column
mat_ind = repmat(ind, statesize_fat,1);        % Matrix of indexes of column
mat_where = repmat(wheretolook, 1, n_hc*n_net); % Indexes of "wheretolook"
           
trans_omega_U=sparse(trans_omega_U);
total_trans_father_U=sparse(trans_omega_U);
total_trans_father_E=sparse(trans_omega_E);
clear trans_omega_U trans_omega_E      %clears now useless (and big) enormous matrices

%% Value Function Iteration
VF=tic;
WR_father=ones(n_occ,statesize_fat);
old_WR_father=0*WR_father;
old_W_father=0*W_father;
old_U_father=0*U_father;

%NO THETA ITERATION REQUIRED ANYMORE

u_state_old=(ones(1,statesize_fat)*(1/statesize_fat))*0.1;
u_state_fat=(ones(1,statesize_fat)*(1/statesize_fat))*0.1;

%SOLVE ONCE J
w_father=piecerate.*productivity_father;    %Piece-rate wages for robustness checks etc.

%NASH-BARGAINED WAGES, TEMPORARY TO CHECK EFFICIENCY
%w_father=piecerate.*productivity_father + (1-piecerate).*b + piecerate.*theta.*kappa; 
w_father=min(w_father,productivity_father);
w_father=max(w_father,0);

jobfind_fat=min(jf_function(theta).*(net_father./sum(((u_state_old').*net_father)./sum(u_state_old))),0.99999);

%START GUESSING THETA FROM ZERO PROFIT
id_minus_trans_E=(eye(statesize_fat)-(lambda.*(1-delta).*(1-lowerbound_probabilities).*total_trans_father_E));
J_father=id_minus_trans_E\((1-lowerbound_probabilities).*(((productivity_father - w_father)))); %using matlab's division

E_J_father=total_trans_father_E*J_father;

E_J_father_TOTAL=zeros(statesize_fat,1);

E_J_father_TOTAL=((sum(jobfind_fat'.*adj1'.*(J_father'))) ...
    ./sum(jobfind_fat'.*adj1'));
        
E_J_father_TOTAL(isnan(E_J_father_TOTAL))=sum(J_father(isnan(E_J_father_TOTAL)))/(sum(isnan(E_J_father_TOTAL)));
E_J_father_TOTAL=(E_J_father_TOTAL.*(10^10))./(10^10);  %Rounding!

    w_father=piecerate.*productivity_father;    %Piece-rate wages for robustness checks etc.
    
    w_father=min(w_father,productivity_father);
    w_father=max(w_father,0);
    
    jobfind_fat=min(jf_function(theta).*(net_father./sum(((u_state_old').*net_father)./sum(u_state_old))),0.99999);
    %Solve worker and firm's problem
    
    iter=0;
    dist=100;
    distW=100;
    distU=100;
    
    while distW+distU > toll
        iter=iter+1;

        WR_father=U_father(wheretolook_trans);    
        
        %Value of reallocation, state by state and replicated for each
        %occupation
        WR_father_REP_horizontally=WR_father';
        scalingdown_factor=(max(WR_father_REP_horizontally,[],2));    %Line-by-line scaling-down (precision)

        WR_father_REP_horizontally_scaleddown=WR_father_REP_horizontally-repmat(scalingdown_factor,1,n_occ);
        sums=sum(exp(WR_father_REP_horizontally_scaleddown./sigma_shocks),2);   %This code rescales the value functions for more precise EXP

        sums_REP=repmat(sums,1,n_occ-1);
        prob_choosing_occ=zeros(statesize_fat,n_occ);
        prob_choosing_occ(:,1:n_occ-1)=((exp(WR_father_REP_horizontally_scaleddown(:,1:n_occ-1)./sigma_shocks)./(sums_REP)));    %This code rescales the value functions for more precise EXP
        prob_choosing_occ(:,n_occ)=1-sum(prob_choosing_occ,2);
        
        %Bounding (im)mobility above
        prob_choosing_occ=min(prob_choosing_occ,upperbound_probabilities);
        prob_choosing_occ=max(prob_choosing_occ,lowerbound_probabilities);
        prob_choosing_occ=prob_choosing_occ./repmat(sum(prob_choosing_occ,2),1,n_occ);
        
        WR_father_rep=sum(prob_choosing_occ.*(WR_father_REP_horizontally),2);
    
        U_father=((b + lambda.*((jobfind_fat.*Eu_W_father + (1-jobfind_fat).*Eu_WR_father ))));

        W_father_provv=((pref_father + w_father + lambda.*((1-delta).*Ee_W_father + delta.*Ee_WR_father)));

       probleave_emp=round(1-((1./(1 + exp((WR_father_rep-W_father_provv)./sigma_shocks)))),10);

       % BOUNDING PROBLEAVE
       probleave_emp=max(probleave_emp,1-upperbound_probabilities);
       probleave_emp=min(probleave_emp,upperbound_probabilities);
               
        W_father=(1-probleave_emp).*(W_father_provv) + probleave_emp.*WR_father_rep;
 
        Ee_W_father=total_trans_father_E*W_father;
        Eu_W_father=total_trans_father_U*W_father;
        
        Eu_WR_father=total_trans_father_U*WR_father_rep;
        Ee_WR_father=total_trans_father_E*WR_father_rep;
        distW=max(abs(W_father-old_W_father));
        distU=max(abs(U_father-old_U_father));
        old_W_father=W_father;
        old_U_father=U_father;
    end

    %This code tries to invert the matrix for faster J computation
    id_minus_trans_E=(eye(statesize_fat)-(lambda.*(1-delta).*repmat((1-probleave_emp),1,statesize_fat).*total_trans_father_E));
    J_father=id_minus_trans_E\((1-probleave_emp).*(((productivity_father - w_father)))); %using matlab's division
    E_J_father=total_trans_father_E*J_father;
    
    cols=reshape(wheretolook,statesize_fat*n_occ,1);   % columns for sparse
    rows=repmat([1:statesize_fat]',n_occ,1);   % rows for sparse
    vals=reshape(prob_choosing_occ, statesize_fat*n_occ,1); % values for sparse 
    trans_occ_fat=sparse(rows,cols,vals);   % create trans_occ matrix
    
    %fprintf('Value function solved \n ');
    probleave_emp_trans=probleave_emp';
    jf_fat_trans=jobfind_fat';
        
    %Solve for steady state distribution over states
    u_state_fat=0.1*ones(1,statesize_fat).*adj1'./sum(adj1);
    u_state_old=u_state_fat*2;
    e_state_fat=((ones(1,statesize_fat).*adj1'./sum(adj1))-u_state_fat);

    e_state_old=e_state_fat*2;

    %Precalculate U transitions
    precalc_transU=trans_occ_fat*total_trans_father_U;

    while (max(abs(u_state_fat-u_state_old)) > toll) || (max(abs(e_state_fat-e_state_old)) > toll)
        u_state_old=u_state_fat;
        e_state_old=e_state_fat;

        %new faster method
        measure1=((1-zeta_par).*((((((u_state_fat)) + ...
            (((probleave_emp_trans).*e_state_fat))))*precalc_transU))) + zeta_par.*initial_ustate_fathers';
        measure2=(1-zeta_par).*((((1-probleave_emp_trans).*e_state_fat)*total_trans_father_E)) + ...
            zeta_par.*initial_estate_fathers';
        
        u_state_fat=((((1-jf_fat_trans).*measure1)) + ...
            (delta.*measure2));
        e_state_fat=(((jf_fat_trans).*measure1)) + ...
            ((1-delta).*measure2);
                   
    end
    
    E_J_father_TOTAL=((sum(u_state_fat.*jobfind_fat'.*(J_father'))) ...
            ./sum(u_state_fat.*jobfind_fat'));
        
    E_J_father_TOTAL(isnan(E_J_father_TOTAL))=sum(J_father(isnan(E_J_father_TOTAL)))/(sum(isnan(E_J_father_TOTAL)));
    E_J_father_TOTAL=(E_J_father_TOTAL*(10^10))./(10^10);  %Rounding
    
res=0;

trans_father_E=sparse(total_trans_father_E);
trans_father_U=sparse(total_trans_father_U);
probleave_emp_fat=probleave_emp;
theta_father=theta;
prob_choosing_occ_fat=prob_choosing_occ;

 if nargin < 4
    save base_cal/fathers.mat trans_father_E trans_father_U trans_occ_fat ...
        total_trans_father_E total_trans_father_U jobfind_fat probleave_emp_fat w_father U_father W_father J_father WR_father_rep ...
        Ee_W_father Eu_W_father Ee_WR_father Eu_WR_father E_J_father u_state_fat e_state_fat net_father theta_father ...
        prob_choosing_occ_fat
else
    outstring=sprintf('%g\\fathers.mat',inputfolder);
    save(outstring,'trans_father_E','trans_father_U','trans_occ_fat','total_trans_father_E','total_trans_father_U',...
        'jobfind_fat','probleave_emp_fat','w_father','U_father','W_father','J_father','WR_father_rep', ...
        'Ee_W_father', 'Eu_W_father','Ee_WR_father','Eu_WR_father','E_J_father','u_state_fat','e_state_fat','net_father',...
        'theta_father','prob_choosing_occ_fat');
end
end